
C====coefficients c,q,d  for one transition===============
      SUBROUTINE CQD1(OM,LAMI,M,M1,LAMM,C,Q,D1)
      REAL*8 OM ,RE,KAP,
     *  XM0,DELX,K3,LAMI,
     *  LAMM(*),C(*),Q(*),D1(*)
      INTEGER M,M1,W,I
C---------------------------------
      IF ( M.GT.M1 ) THEN
       DELX=DSQRT(LAMM(M))-DSQRT(LAMM(M-1))
       K3=DELX/3.
       XM0=DSQRT(LAMM(M1+1))
      END IF
      DO 10 I=1, M
       Q(I)=0.D 00
       D1(I)=0.D 00
  10  CONTINUE
      DO  20 I=1, M1
   20  C(I)=1.D 00
       C(M1+1)=K3
      DO 30 I=M1+2, M-1, 2
       C(I)=4.*K3
       C(I+1)=2.*K3
  30  CONTINUE
       C(M)=K3
       IW=0
      DO 40 I=M1+1, M
      IF (DABS(OM-LAMM(I)).LE. 0.0001) THEN
        IW=I
C       PRINT 21,IW
C  21   FORMAT('   IW= ',I4)
        GOTO 50
      END IF
  40  CONTINUE
  50  IF (IW.EQ.M1+1 ) THEN
       Q(IW)=C(IW)
       Q(IW+1)=-1./2.*C(IW)
      ELSE IF (IW.EQ.M1+2) THEN
       Q(IW-1)=-1./2.*C(IW)
       Q(IW)=C(IW)
       Q(IW+1)=-1./2.*C(IW)
      ELSE IF ((IW.GE.M1+3) .AND.(IW.LE.M-2))THEN
       Q(IW-2)=1./6.*C(IW)
       Q(IW-1)=2./3.*C(IW)
       Q(IW)=C(IW)
       Q(IW+1)=2./3.*C(IW)
       Q(IW+2)=1./6.*C(IW)
      ELSE IF (IW.EQ.M-1) THEN
       Q(IW+1)=-1./2.*C(IW)
       Q(IW)=C(IW)
       Q(IW-1)=-1./2.*C(IW)
      ELSE
       Q(IW)=C(IW)
       Q(IW-1)=-1./2.*C(IW)
      END IF
  60   KAP=XM0
        RE=0.D 00
      DO 70 W=1, M
      IF ( W.EQ.IW ) THEN
        D1(IW)=0.D 00
      ELSE
        D1(W)=1./(OM-LAMM(W)+LAMI)
      END IF
      IF (W.GT.M1) THEN
        KAP=DSQRT(LAMM(W))
        D1(W)=2.*KAP*D1(W)
      END IF
 70   CONTINUE
 150  RETURN
      END
